## Your Name:

# CIDM 3312 Midterm Exam Part 2 (60 Points)

Your task is to create a console-based gradebook that allows a professor to input GPAs for students in different courses using Entity Framework Core. Write an Entity Framework Core console app that models the following business rules:

  1. A student can enroll in many classes.
  2. Each course can have many students enrolled in it.
  
  
  ![Image of ERD](https://i.imgur.com/Wbm12qU.png)
  
NOTE: This ERD lacks the foreign keys and navigation properties. You must make it implementable in your code and add any additional properties as required by the features listed below.

## Requirements
  1. Use a SQLite database and store student and course data persistently. **Add a property to store each student's GPA in each specific course.**
  2. Seed the database with at least 2 courses and 4 students. Enroll each student into one or more courses so that each course has at least 2 students. These can be hard-coded.
  3. Allow the user to **LIST** all the courses along with students and their GPA in each course. List the students underneath each course along with their GPA.\
          - Within each course, sort the students by GPA from highest to lowest.
  4. Allow the user to **UPDATE** the GPA for each student in a specific course. Ensure that the inputted GPA is between 0.0 and 4.0.
  5. Handle **all** invalid input without crashing including invalid students and courses.
  6. Extra Credit: Allow the user to **DROP** a student from a course. The student should still exist in the database but won't be associated with that course anymore.
  7. Remember to comment your code.
  
Your app should implement the above requirements in a separate class for LIST, UPDATE, and DROP similar to Homework 2 and Homework 4 using a separate class and methods within that class. Those features should be available to the user through a text interface menu.

This exam is meant to be completed **INDIVIDUALLY**. Cheating or copying on this exam will result in a ZERO for the exam and at the professor's discretion, a zero for the entire course. Notes are allowed.

## Submit your assignment
1. Save your program and run it. At the terminal prompt, type `dotnet run`.
2. Edit `README.md` and put your name at the top.
3. Push your changes to GitHub:
    - Click the source control icon in VS Code
    - Type in a commit message
    - Click the checkbox icon to commit. (Click yes on the message box to stage your commit)
    - Click the 3 dots icon (...) for more actions and click Push.
4. Or you can push your changes to GitHub using the Terminal:
    ```
    git add -A
    git commit -m "Ready for grading"
    git push
    git status
    ```
4. Verify that your changes are on GitHub.
